<?php
/*
$twt = \plugins\twitter::get('Pixelsize');

$tl = $twt->timeline(5);

while ($tl->read()) {
	echo $tl->text;
}
*/

namespace plugins\twitter
{
	class Main extends \Ext\Plugin
	{
		public function timeline($count = 5, $since_id = '')
		{
			if (!$this->instance_id) return false;
			if ($count == 0) return false;
		
			// Prepare arguments
			$args = array();
			$argsString = '';
			
			if ($count) $args[] = 'count=' . $count;
			if ($since_id) $args[] = 'since_id=' . $since_id;
			$args[] = 'trim_user=true';
	
			if (count($args))
				$argsString = '?' . implode('&', $args);

			
			// Retreive timeline
			$handle = @fopen('http://twitter.com/statuses/user_timeline/' . $this->instance_id . '.json' . $argsString, 'rb');
			$contents = '';
			
			if(!$handle) return new \Readers\Listing(); //FIX PARA CUANDO FALLA EN ABRIR EL TIMELINE
			
			while (!feof($handle))
			{
				$contents .= fread($handle, 8192);
			}
			fclose($handle);
			
			$rawTimeline = json_decode($contents);
			
			
			// Prepare result for return
			
			$total = count($rawTimeline);
			
			$timeline = new \Readers\Table();
			
			for ($i = 0; $i < $total; $i ++)
			{
				// Text works
				$text = $rawTimeline[$i]->text;
				
				// Pictures : Find
				preg_match_all('/http:\/\/twitpic.com\/([a-z0-9]+)/', $text, $matches);
				
				// Pictures : Set array
				$pictures = new \Readers\Table();
				
				if (count($matches))
				{
					for ($p = 0; $p < count($matches[0]); $p ++)
					{
						$pictures->append (array(
											'id' => $matches[1][$p],
											'link' => $matches[0][$p],
											'mini' => 'http://twitpic.com/show/mini/' . $matches[1][$p],
											'thumb' => 'http://twitpic.com/show/thumb/' . $matches[1][$p]
											));
					}
				}
				
				// Remove pictures from final text
				if (strtolower($this->config()->get('plugins:twitter:tweets:removePictures')) == 'true')
					$text = preg_replace('/http:\/\/twitpic.com\/([a-z0-9]+)/', '', $text);
					
				
				// Mentions
				preg_match_all('/@([(a-zA-Z0-9_)]+)/', $text, $matches);
				$timeline->mentioned_users = new \Readers\Listing($matches[1]);
				if (strtolower($this->config()->get('plugins:twitter:tweets:removeMentions')) == 'true')
					$text = preg_replace('/@([(a-zA-Z0-9_)]+)(,)?( )??/', '', $text);
				
				
				// Hashtags
				preg_match_all('/#([(a-zA-Z0-9_)]+)/', $text, $matches);
				$timeline->hashtags = new \Readers\Listing($matches[1]);
				if (strtolower($this->config()->get('plugins:twitter:tweets:removeHashtags')) == 'true')
					$text = preg_replace('/#([(a-zA-Z0-9_)]+)(,)?( )??/', '', $text);
					
					
				// Convert user and URL links
				if (strtolower($this->config()->get('plugins:twitter:tweets:makeLinks')) == 'true') {
					$text = preg_replace("/([\w]+:\/\/[\w-?&;#~=\.\/\@]+[\w\/])/i", '<a target="_blank" href="$1">$1</A>', $text);
					$text = preg_replace('/@([(a-zA-Z0-9_)]+)/', '<a href="http://twitter.com/$1" rel="nofollow">@$1</a>', $text);
					$text = preg_replace('/#([(a-zA-Z0-9_)]+)/', '<a href="http://twitter.com/$1" rel="nofollow">#$1</a>', $text);
				}
				
				
				// Append to timeline
				$timeline->append(array('created_at' => new timestamp($rawTimeline[$i]->created_at),
										'raw_text' => $rawTimeline[$i]->text,
										'source' => $rawTimeline[$i]->source,
										'reply_to' => $rawTimeline[$i]->in_reply_to_screen_name,
										'text' => $text,
										'pictures' => $pictures
				));
			}
			
			return $timeline;
		}
	}
	
	class timestamp
	{
		public $raw_timestamp = -1;
		public $timestamp = -1;
		
		public function __construct ($time)
		{
			$this->raw_timestamp = $time;
			$this->timestamp = strtotime($time);
		}
		
		public function date($format)
		{
			return strftime($format, $this->timestamp);
		}
	}
}

?>