<?php
namespace Env\Hunter { final class Hunter { static private $lh, $instance; public function __construct(\Env\Hunter\Logger &$lh) { static $called = false; if($called) return; $called = true; self::$lh = &$lh; self::$instance = &$this; } public function warning($title, $desc = null, $tip = null) { if($title instanceof \HunterException) { $he = $title; $title = $he->getTitle(); $desc = $he->getDescription(); $tip = $he->getTip(); $component = $he->getComponent(); } else { $component = null; } $trace = $this->processTrace(debug_backtrace(true)); self::$lh->addArtise($trace, Warning, $title, $desc, $tip, $component); return false; } public function error($title, $desc = null, $tip = null) { if($title instanceof \HunterException) { $he = $title; $title = $he->getTitle(); $desc = $he->getDescription(); $tip = $he->getTip(); $component = $he->getComponent(); } else { $component = null; } $trace = $this->processTrace(debug_backtrace(true)); self::$lh->addArtise($trace, Error, $title, $desc, $tip, $component); return false; } public function flag($title, $desc = null) { if($title instanceof \HunterException) { $he = $title; $title = $he->getTitle(); $desc = $he->getDescription(); $tip = $he->getTip(); } $trace = $this->processTrace(debug_backtrace(true)); self::$lh->addArtise($trace, Flag, $title, $desc); return false; } public function enabled($status = null) { if($status !== null) self::$lh->enabled = (bool)$status; else return self::$lh->enabled; } private function processTrace($trace) { $reached_component = false; $next_step = false; $components_ns = array('renders', 'actions', 'plugins'); $components_ext = array('Layout'); array_walk($trace, function(&$step) use (&$reached_component, &$next_step, $components_ns, $components_ext) { if($reached_component && !$next_step) { $step = array(); return false; } unset($step['args']); if(isset($step['object'])) { $object_class = get_class($step['object']); switch($object_class) { case 'Env\Rendering\Painter': $object_class = 'painters\\' . $step['object']->path; $step['function'] = $step['object']->method; break; case 'Ext\Rendering\Layout': $step['graphic'] = $step['object']->filename; break; } $step['object'] = $object_class; $sliced_object = explode('\\', $step['object']); if(in_array($sliced_object[0], $components_ns)) $reached_component = true; $sliced_object = explode('\\', $step['object']); if(isset($sliced_object[2])) { if(in_array($sliced_object[2], $components_ext)) $reached_component = true; } $next_step = true; } }); return $trace; } } } ?>
