<?php
namespace Env\Routing { final class Procedure { private $actions = array(), $redirects = array(), $return_states = array(), $on_error, $on_success, $status = null; public function status($actions = null) { if($actions == null) return $this->status; if(is_array($actions)) { $status = true; foreach($actions as $action) { if(isset($this->return_states[$action])) $status = $status && $this->return_states[$action]; } return $status; } elseif (is_string($actions)) { if(isset($this->return_states[$action])) return $this->return_states[$action]; } else { \Artise::hunter()->warning('W0003', array('DESC_W0003', array( 'arg' => 'actions', 'type' => gettype($actions), 'allowed_types' => 'string, array' ))); } return false; } public function __construct($xmlElement) { if (!is_object($xmlElement)) throw new \HunterException('W0002'); if (!property_exists($xmlElement, 'action')) throw new \HunterException('W0002'); foreach($xmlElement->action as $action) { $this->actions[] = (string)$action->attributes()->src; } foreach($xmlElement->redirect as $redirect) { $this->redirects[(string)$redirect->attributes()->state] = \Artise::router()->uri()->format((string)$redirect->attributes()->target); } if (property_exists($xmlElement, '@attributes')) { $att = $xmlElement->attributes(); if (property_exists($att, 'on_error')) $this->on_error = (string)$att->onerror; if (property_exists($att, 'on_success')) $this->on_success = (string)$att->onsuccess; } } public function runActions(&$site, &$devkit) { $actions_return = array(); if(file_exists($site->router()->getPath(Artise_Path_Actions) . '/commons.func.php')) include $site->router()->getPath(Artise_Path_Actions) . '/commons.func.php'; foreach($this->actions as $action_path) { try { $path = \Artise::router()->getPath(Artise_Path_Actions) . DS; $action_file_path = $path . DS . $action_path . '.php'; if(!file_exists($action_file_path)) throw new \HunterException( new \Env\Source\DummyIdiom('E0050', array('element' => 'Action')), new \Env\Source\DummyIdiom('file_path_abstract', array( 'path' => $path, 'filename' => $action_path)), 'TIP_E0050', 'router'); if(!is_readable($action_file_path)) throw new \HunterException( new \Env\Source\DummyIdiom('E0051', array('element' => 'Action')), new \Env\Source\DummyIdiom('file_path_abstract', array( 'path' => $path, 'filename' => $action_path)), 'TIP_E0051'); include $action_file_path; $parts = explode('/', $action_path); $class_name = ''; if (count($parts) > 1) { $class_name = $parts[count($parts) - 1]; unset($parts[count($parts) - 1]); $action_ns = 'actions\\' . implode('\\', $parts); } else { $class_name = $action_path; $action_ns = 'actions'; } $ns_path = '\\' . $action_ns . '\\'; $action_path = $ns_path . $class_name; if(class_exists($action_path, false)) { $action = new $action_path($site, $devkit); if(get_parent_class($action) != 'Ext\Action') throw new \HunterException( new \Env\Source\DummyIdiom('E0060', array( 'element' => 'Action', 'name' => $class_name)), new \Env\Source\DummyIdiom('namespace_path_abstract', array('path' => $ns_path, 'filename' => $class_name)), new \Env\Source\DummyIdiom('TIP_E0060_A'), 'router'); } else { throw new \HunterException( new \Env\Source\DummyIdiom('E0053', array( 'element' => 'Action', 'name' => $class_name)), new \Env\Source\DummyIdiom('namespace_path_abstract', array('path' => $ns_path, 'filename' => $class_name)), new \Env\Source\DummyIdiom('TIP_W0053', array('component' => 'action')), 'router'); } $actions_return[] = $this->return_states[$action_path] = $action->execute(); if (is_bool($this->return_states[$action_path]) === false) $this->return_states[$action_path] = null; else $this->updateStatus($this->return_states[$action_path]); } catch (\HunterException $e) { \Artise::hunter()->warning($e); } } return $actions_return; } public function resultRedirect() { $status = $this->status(); if($status === true && $this->on_success) return $this->on_success; if($status === false && $this->on_error) return $this->on_error; } private function updateStatus($new_status) { if (!is_bool($new_status)) return; if($this->status === null) $this->status = $new_status; else $this->status = $this->status && $new_status; } } } ?>
